using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_ControlGastos._3_Vistas.Controladoras;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_ControlGastos._3_Vistas
{
    public partial class P_OrdenComisionServicioHospedaje : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;

        private P_OrdenComisionServicioHospedaje_Controladora g_obj_Controladora;

        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla
        //Exferia_fechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Fecha { get { return ex_usc_P_OrdenComisionServicioHospedaje_Fecha; } }

        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_Internacional { get { return ex_chk_P_OrdenComisionServicioHospedaje_Internacional; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Establecimiento { get { return ex_lbl_P_OrdenComisionServicioHospedaje_Establecimiento; } }
        internal Exferia_Label Exferia_Label_NumeroDias { get { return ex_lbl_P_OrdenComisionServicioHospedaje_NumeroDias; } }
        internal Exferia_Label Exferia_Label_PrecioPorNoche { get { return ex_lbl_P_OrdenComisionServicioHospedaje_PrecioPorNoche; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Hospedaje { get { return ex_Paginador; } }

        //Exferia_RichTextBox_ConBotones
        internal Exferia_RichTextBox_ConBotones Exferia_RichTextBox_ConBotones_Observaciones { get { return ex_usc_P_OrdenComisionServicioHospedaje_Observaciones; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Establecimiento { get { return ex_txt_P_OrdenComisionServicioHospedaje_Establecimiento; } }
        internal Exferia_TextBox Exferia_TextBox_NumeroDias { get { return ex_txt_P_OrdenComisionServicioHospedaje_NumeroDias; } }
        internal Exferia_TextBox Exferia_TextBox_PrecioPorNoche { get { return ex_txt_P_OrdenComisionServicioHospedaje_PrecioPorNoche; } }

        #endregion

        #region Constructor
        public P_OrdenComisionServicioHospedaje(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                                   DateTime _dtt_FechaTrabajo,
                                                   string _str_TituloAuxiliar,
                                                   long _lng_idOrdenComisionServicioCabecera,
                                                   List<INTERNO_Permisos_Modelo> _lst_INTERNO_Permisos_Modelo,
                                                   string _str_Estado_PantallaOrigen)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                g_obj_Controladora = new P_OrdenComisionServicioHospedaje_Controladora(this);

                //id de la tabla relacionada
                g_obj_Controladora.g_lng_idOrdenComisionServiciosCabecera = _lng_idOrdenComisionServicioCabecera;

                //Empresa seleccionada y fecha de trabajo
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTG_ORDENCOMISIONSERVICIOSHOSPEDAJE);

                //Bucar Permisos
                g_lst_INTERNO_Permisos_Modelo = _lst_INTERNO_Permisos_Modelo;

                g_obj_Controladora.g_str_Estado = _str_Estado_PantallaOrigen;

                //Poner los Botones que no se pueden poner bloqueados o de solo lectura
                ex_btn_P_OrdenComisionServicioHospedaje_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_OrdenComisionServicioHospedaje_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si el estado de la pantalla de origen es cerrado bloquear la pantalla
                if (_str_Estado_PantallaOrigen.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento + " del " + _str_TituloAuxiliar;

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_OrdenComisionServicioHospedaje) + "/" + nameof(P_OrdenComisionServicioHospedaje));
                    }
                }
                //....................................................................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_OrdenComisionServicioHospedaje) + "/" + nameof(P_OrdenComisionServicioHospedaje));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                this.Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de Pantalla
        private void P_OrdenComisionServicioHospedaje_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION 
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
                #endregion
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_OrdenComisionServicioHospedaje) + "/" + nameof(P_OrdenComisionServicioHospedaje_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_OrdenComisionServicioHospedaje_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Hacemos foco al primer control.
                        ex_usc_P_OrdenComisionServicioHospedaje_Fecha.Exferia_FechaSeleccion_Foco();

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Hospedaje.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Hospedaje.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_OrdenComisionServicioHospedaje) + "/" + nameof(P_OrdenComisionServicioHospedaje_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        private void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Hospedaje.Visible)
            {
                Exferia_Paginador_Hospedaje.Visible = _bol_Activar;
            }

            if (ex_btn_P_OrdenComisionServicioHospedaje_Borrar.Enabled)
            {
                ex_btn_P_OrdenComisionServicioHospedaje_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar
        private void ex_btn_P_OrdenComisionServicioHospedaje_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {

            if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                //Si el Documento esta cerrado no puedo grabar
                if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                }
                else
                {
                    //Añadiendo
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        g_obj_Controladora.GrabarDatos(true);
                    }
                    //Modificando
                    else
                    {
                        g_obj_Controladora.GrabarDatos(false);
                    }
                }
            }

        }

        private void ex_btn_P_OrdenComisionServicioHospedaje_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                //Si el Documento esta cerrado no puedo borrar
                if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                }
                else
                {
                    g_obj_Controladora.BorrarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifico algo
        private void ex_Exferia_TextBox_Evento_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        public void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Hospedaje.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Hospedaje.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Hospedaje.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Hospedaje.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Hospedaje.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Hospedaje.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }

        #endregion
    }
}
